<!DOCTYPE html>

<html lang="en" data-content_root="../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>src.general &#8212; pandas 2.1.1 documentation</title>
    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=fa44fd50" />
    <link rel="stylesheet" type="text/css" href="../../_static/alabaster.css?v=233b9934" />
    <script src="../../_static/documentation_options.js?v=841abef3"></script>
    <script src="../../_static/doctools.js?v=888ff710"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
   
  <link rel="stylesheet" href="../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for src.general</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">.common</span> <span class="kn">import</span> <span class="n">processor</span><span class="p">,</span> <span class="n">params_to_dict</span>
<span class="kn">import</span> <span class="nn">logging</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">click</span>
<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>


<div class="viewcode-block" id="melt">
<a class="viewcode-back" href="../../api/src.html#src.general.melt">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
    <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
    <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
    <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
    <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">melt</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Unpivot a DataFrame from wide to long format, optionally leaving</span>
<span class="sd">    identifiers set.</span>

<span class="sd">    This function is useful to massage a DataFrame into a format where one or</span>
<span class="sd">    more columns are identifier variables (id_vars), while all other columns,</span>
<span class="sd">    considered measured variables (value_vars), are “unpivoted” to the row</span>
<span class="sd">    axis, leaving just two non-identifier columns, &#39;variable&#39; and &#39;value&#39;.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    \b</span>
<span class="sd">        id_vars=None</span>
<span class="sd">        value_vars=None</span>
<span class="sd">        var_name=None</span>
<span class="sd">        value_name=&#39;value&#39;</span>
<span class="sd">        col_level=None</span>
<span class="sd">        ignore_index=True</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="n">logging</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;&#39;melt&#39;ing table with params: </span><span class="si">{</span><span class="n">pd_params</span><span class="si">}</span><span class="s2">.&quot;</span><span class="p">)</span>
        <span class="k">yield</span> <span class="n">pd</span><span class="o">.</span><span class="n">melt</span><span class="p">(</span><span class="n">df</span><span class="p">,</span> <span class="o">**</span><span class="n">pd_params</span><span class="p">)</span></div>



<div class="viewcode-block" id="pivot">
<a class="viewcode-back" href="../../api/src.html#src.general.pivot">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">pivot</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Return reshaped DataFrame organized by given index / column values.</span>

<span class="sd">    Reshape data (produce a “pivot” table) based on column values. Uses unique</span>
<span class="sd">    values from specified index / columns to form axes of the resulting</span>
<span class="sd">    DataFrame. This function does not support data aggregation, multiple values</span>
<span class="sd">    will result in a MultiIndex in the columns. See the User Guide for more on</span>
<span class="sd">    reshaping.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    \b</span>
<span class="sd">        columns</span>
<span class="sd">        index=_NoDefault.no_default</span>
<span class="sd">        values=_NoDefault.no_default</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="k">yield</span> <span class="n">df</span><span class="o">.</span><span class="n">pivot</span><span class="p">(</span><span class="o">**</span><span class="n">pd_params</span><span class="p">)</span></div>



<div class="viewcode-block" id="merge">
<a class="viewcode-back" href="../../api/src.html#src.general.merge">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">merge</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Merge DataFrame or named Series objects with a database-style join. For</span>
<span class="sd">    a more efficient merge with multiple dataframes, see `join`.</span>

<span class="sd">    *Note: This operation is performed reductively.* That is, the first two</span>
<span class="sd">    dataframes are merged. The resulting dataframe is merged with the third;</span>
<span class="sd">    that result, merged with the fourth; and so on until all dataframes are</span>
<span class="sd">    merged.</span>
<span class="sd">    </span>
<span class="sd">    If this behavior is not desired, for example, if merge criteria different</span>
<span class="sd">    from that used to merge the first two dataframes is desired when merging</span>
<span class="sd">    the result with the third, then merge the first two before reading in the</span>
<span class="sd">    third, e.g.</span>

<span class="sd">    \b</span>
<span class="sd">        ```</span>
<span class="sd">        pd</span>
<span class="sd">            read -f &quot;one.csv&quot; read -f &quot;two.csv&quot;</span>
<span class="sd">            merge -p &quot;...&quot;</span>
<span class="sd">            read -f &quot;three.csv&quot;</span>
<span class="sd">            merge -p &quot;...&quot;</span>
<span class="sd">        ```</span>

<span class="sd">    A named Series object is treated as a DataFrame with a single named column.</span>

<span class="sd">    The join is done on columns or indexes. If joining columns on columns, the</span>
<span class="sd">    DataFrame indexes will be ignored. Otherwise if joining indexes on indexes</span>
<span class="sd">    or indexes on a column or columns, the index will be passed on. When</span>
<span class="sd">    performing a cross merge, no column specifications to merge on are allowed.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    \b</span>
<span class="sd">        how=[&#39;left&#39;, &#39;right&#39;, &#39;outer&#39;, &#39;inner&#39;, &#39;cross&#39;]. Default:&#39;inner&#39;</span>
<span class="sd">        on: label or list</span>
<span class="sd">        left_on: label or list</span>
<span class="sd">        right_on: label or list</span>
<span class="sd">        left_index=False</span>
<span class="sd">        right_index=False</span>
<span class="sd">        sort=False</span>
<span class="sd">        suffixes=(&#39;_x&#39;, &#39;_y&#39;)</span>
<span class="sd">        copy: bool. Default: True.</span>
<span class="sd">        indicator=False,</span>
<span class="sd">        validate: [&quot;1:1&quot;, &quot;1:m&quot;, &quot;m:1&quot;, &quot;m:m&quot;]. Default: None.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">result</span> <span class="o">=</span> <span class="kc">None</span>
    <span class="k">for</span> <span class="n">df</span> <span class="ow">in</span> <span class="n">dfs</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">result</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">result</span> <span class="o">=</span> <span class="n">df</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
            <span class="n">result</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">merge</span><span class="p">(</span><span class="n">result</span><span class="p">,</span> <span class="n">df</span><span class="p">,</span> <span class="o">**</span><span class="n">pd_params</span><span class="p">)</span>
    <span class="k">yield</span> <span class="n">result</span></div>



<div class="viewcode-block" id="join">
<a class="viewcode-back" href="../../api/src.html#src.general.join">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">join</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Join columns of another DataFrame.</span>

<span class="sd">    See also: `merge`. This function (join) is more efficient at combining</span>
<span class="sd">    multiple dataframes.</span>

<span class="sd">    Join columns with other DataFrame either on index or on a key column.</span>
<span class="sd">    Efficiently join multiple DataFrame objects by index at once by passing a</span>
<span class="sd">    list.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    \b</span>
<span class="sd">        on: label or list</span>
<span class="sd">        how=[&#39;left&#39;, &#39;right&#39;, &#39;outer&#39;, &#39;inner&#39;, &#39;cross&#39;]. Default:&#39;left&#39;</span>
<span class="sd">        lsuffix=&#39;&#39;</span>
<span class="sd">        rsuffix=&#39;&#39;</span>
<span class="sd">        sort=False</span>
<span class="sd">        validate: [&quot;1:1&quot;, &quot;1:m&quot;, &quot;m:1&quot;, &quot;m:m&quot;]. Default: None.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
    <span class="n">dataframes</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">dfs</span><span class="p">)</span>
    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">dataframes</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
        <span class="c1"># No dataframes have been read in.</span>
        <span class="n">logging</span><span class="o">.</span><span class="n">warning</span><span class="p">(</span><span class="s2">&quot;No dataframes when attempting a join.&quot;</span><span class="p">)</span>
        <span class="k">yield</span>
    <span class="k">elif</span> <span class="nb">len</span><span class="p">(</span><span class="n">dataframes</span><span class="p">)</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
        <span class="c1"># Only one dataframe has been read.</span>
        <span class="n">logging</span><span class="o">.</span><span class="n">warning</span><span class="p">(</span><span class="s2">&quot;Only one dataframe present when attempting a join. &quot;</span>\
                        <span class="s2">&quot;DataFrame unchanged.&quot;</span><span class="p">)</span>
        <span class="k">yield</span> <span class="n">dataframes</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">lhs</span><span class="p">,</span> <span class="n">other</span> <span class="o">=</span> <span class="n">dataframes</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">dataframes</span><span class="p">[</span><span class="mi">1</span><span class="p">:]</span>
        <span class="k">yield</span> <span class="n">lhs</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">other</span><span class="p">,</span> <span class="o">**</span><span class="n">pd_params</span><span class="p">)</span></div>



<div class="viewcode-block" id="concat">
<a class="viewcode-back" href="../../api/src.html#src.general.concat">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="k">def</span> <span class="nf">concat</span><span class="p">(</span><span class="n">dfs</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Concatenate pandas objects along a particular axis.</span>

<span class="sd">    Allows optional set logic along the other axes.</span>

<span class="sd">    Can also add a layer of hierarchical indexing on the concatenation axis,</span>
<span class="sd">    which may be useful if the labels are the same (or overlapping) on the</span>
<span class="sd">    passed axis number.</span>

<span class="sd">    ## Parameters</span>

<span class="sd">    \b</span>
<span class="sd">        axis=0</span>
<span class="sd">        join=&#39;outer&#39;</span>
<span class="sd">        ignore_index=False</span>
<span class="sd">        keys=None</span>
<span class="sd">        levels=None</span>
<span class="sd">        names=None</span>
<span class="sd">        verify_integrity=False</span>
<span class="sd">        sort=False</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">pd_params</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
    <span class="k">yield</span> <span class="n">pd</span><span class="o">.</span><span class="n">concat</span><span class="p">(</span><span class="nb">list</span><span class="p">(</span><span class="n">dfs</span><span class="p">),</span> <span class="o">**</span><span class="n">pd_params</span><span class="p">)</span></div>

</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../index.html">pandas</a></h1>








<h3>Navigation</h3>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../pandas.html">Reference</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../license.html">License</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../index.html">Documentation overview</a><ul>
  <li><a href="../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2023, Branden Kappes.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.13</a>
      
    </div>

    

    
  </body>
</html>